VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5490
   ClientLeft      =   240
   ClientTop       =   1155
   ClientWidth     =   8025
   LinkTopic       =   "Form1"
   ScaleHeight     =   366
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   535
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------
'  TV8 Sample 2 : Particles effect.
'----------------------------------
' Powered by TrueVision 8
' based on TV7 sample 8.
'


Public WithEvents TV         As TrueVision8
Attribute TV.VB_VarHelpID = -1
Public Scene                As Scene8
Public Key                  As InputEngine8
Public Scr                  As Screen8

'Don't forget WithEvents in order to give
'the velocity and the lifetime of the new particle
'/ N'oubliez pas WithEvents afin de pouvoir
'donner une nouvelle vlocit et couleur  la particule
Public WithEvents Particle  As ParticleSystem8
Attribute Particle.VB_VarHelpID = -1
'See the Particle_NewParticle event / Allez voir l'venement Particle_NewParticle

' 1. Fountain !
Public ParticleTexture      As Texture8

Private CurrentColor        As D3DCOLORVALUE
Private CurrentLifeTime     As Single
Private CurrentPower        As Single

'Some declarations
Private Posx                As Single
Private posy                As Single
Private posz                As Single
Private ang                 As Single
Private AffText             As Boolean
Private isRunning           As Boolean
Private Sub Form_Load()
'just some notes...

'when dimensioning an object using the 'New' keyword instead of explicitly setting a reference to it, COM
'DOES NOT automatically release and decrement the ref count when you set it to nothing. In addition, by dimensioning out the
'object that way, can get you into SERIOUS debug probs later, with hidden refs. It's ALWAYS good practice to explicitly
'reference your objects...

'using 'With' and/or nested 'With' statements can speed up access times to complex objects.

'errr, myself personally, i don't like to run fullscreen apps for tutorials or samples, UNLESS i specifically make them so..
'there's no real way of stepping thru code to see what's going on..unless you want to alt-tab back an forth..and that,
'obviously can get to be a nitemare...give ppl an option..start them windowed, and have the fullscreen init commented out..
'that way they can just comment it back in..

'loops...i understand that you want to have the tightest possible rendering loop, however, in windowed mode, it makes sense to be able
'to use the mouse..so play nice with other apps..use a 'DoEvents' in your 'Do While/Until' loops with a boolean to jump out...


Set TV = New TrueVision8
Set Scene = New Scene8
Set Scr = New Screen8





'Init TrueVision / Initialise TrueVision
'TV.Init3DFullscreen 640, 480, 16
Me.Show
isRunning = TV.Init3DWindowedMode(Me.hWnd)
'grab keys after engine init
Set Key = New InputEngine8
' Load the particle texture :/ Charge la texture de la particule
TV.SetSearchDirectory App.Path
Set ParticleTexture = Scene.LoadTexture("snow.bmp", 32, 32)

'Init the billboard particles system :
' We start with no particle
' All the particles will be created with the generator
' and we can change their velocity and their lifetime with
' the NewParticle event
'/'
'Initialise le systme de particules billboard
' On dmarre avec aucune particule
' Toutes les particules seront cres par le gnrateur
' et l'vnement NewParticle
Set Particle = New ParticleSystem8
With Particle
    .CreateBillboardSystem 2000, 0, 3, Vector(0, 50, 0), 0, ParticleTexture
    
    'Set the current color & current lifetime & current power generator
    '/ Configure la couleur, la dure de vie des particules et la puissance du gnrateur
    CurrentColor = ColorValue(1, 1, 1, 1)
    
    CurrentLifeTime = 4
    CurrentPower = 2
    
    'Change the alpha in function of the lifetime
    '(the particle loses energy...)
    '/ Change la valeur alpha en fonction du temps
    '(la particule perd de l'nergie
    .SetAlphaBlendingMode TV_CHANGE_ALPHA, D3DBLEND_SRCALPHA, D3DBLEND_ONE
    
    'Create a new particle every 5ms
    'Cre une nouvelle particule toutes les 5ms
    .SetGeneratorSpeed 5
    
    'Set up the gravity and the bounce factor
    'Configure la gravit et le facteur de rebondissement
    .SetGravity 1.5, 0.3
    
    'Set Particle speed
    'Vitesse de la particule
    .SetParticleSpeed 0.05
End With
'The usual Do-loop
ang = 3.14 / 2
posz = -100
AffText = True

With TV
    Do Until (Key.IsKeyPressed(TV_KEY_ESCAPE) = True) Or isRunning = False
        DoEvents
        'clear backbuffer
        .Clear
        
        'Set up the camera
        'We needn't a complicated camera class
        'so we'll use the standard camera functions of the Scene object
        '/ Change la camra
        'Nous n'avons pas besoin d'une classe camra complique
        'alors nous utiliserons les fonctions standards de l'objet Scene
        Scene.SetCamera Posx, 50, posz, Posx + Cos(ang), 50, posz + Sin(ang)
        
        
        'Render particles
        'Dessine les particules
        'TV.GetDevice3D.SetRenderState D3DRENDERSTATE_LIGHTING, True
        With Particle
            .RenderParticles
            'Update particles:
            '/ Met  jour les particules
            .UpdateParticles TV_UPDATE_BOUNCE_ON_Y0_PLANE Or TV_UPDATE_GENERATOR
        End With
        'Draw some help info in the bottom :
        '/Ecris quelques infos en bas de l'cran
        ' Scr.SetDrawColor RGB(256, 0, 0)
        If AffText = True Then
            If isRunning Then
                With Scr
                    .DrawFilledBox 0, Me.ScaleHeight - 130, Me.ScaleWidth, Me.ScaleHeight, RGBA(0.2, 0.2, 0, 0.6), True
                    .DrawText "(H) : Hide/Show this information", 10, (Me.ScaleHeight - 130) + 15, &HFF00FF00
                    .DrawText "(Space) : Change particle color / Change la couleur des particules", 10, (Me.ScaleHeight - 130) + 30, &HFF00FF00
                    .DrawText "(+/-) : Change particle lifetime / Change la dure de vie des particules " + CStr(Int(CurrentLifeTime * 10) / 10), 10, (Me.ScaleHeight - 130) + 45, &HFF00FF00
                    .DrawText "(Z/X) : Change particle size " & CStr(Particle.ParticleSize), 10, (Me.ScaleHeight - 130) + 60, &HFF00FF00
                    .DrawText "(S) : Move particle emettor / Fait bouger le gnrateur de particules", 10, (Me.ScaleHeight - 130) + 75, &HFF00FF00
                    .DrawText "(Arrow Key) : Move Camera / Bouge la camra", 10, (Me.ScaleHeight - 130) + 90, &HFF00FF00
                    .DrawText "(PageDown / PageUp) : Change emittor power / Change la puissance du gnrateur", 10, (Me.ScaleHeight - 130) + 105, &HFF00FF00
                    .DrawText "Particle Number :" + CStr(Particle.GetActiveParticlesNumber), 10, 10, RGBA(0, 1, 1, 1)
                End With
            End If
        End If
        If isRunning Then
            .RenderToScreen
        End If
        'Change color if you press space key
        'Change la couleur si vous pressez sur la barre d'espace
        With Key
            If .IsKeyPressed(DIK_SPACE) = True Then
                CurrentColor = ColorValue(Rnd, Rnd, Rnd, 1)
            End If
            
            'If you press on 's' the emittor moves around a circle.
            'Si vous appuyez sur 's', l'metteur bouge autour en formant un cercle
            If .IsKeyPressed(TV_KEY_S) = True Then
                MoveEmettor = Not MoveEmettor
            End If
            
            'if you press on '+/-' increase/decrease particle lifetime
            'Si Vous appuyez sur '+/-' augmente/rduit la dure de vie des particules
            If .IsKeyPressed(TV_KEY_ADD) = True Then
                CurrentLifeTime = CurrentLifeTime - (CurrentLifeTime < 15) * TV.TimeElapsed / 200
            End If
            If .IsKeyPressed(TV_KEY_SUBTRACT) = True Then
                CurrentLifeTime = CurrentLifeTime + (CurrentLifeTime > 0) * TV.TimeElapsed / 200
            End If
            
            If .IsKeyPressed(TV_KEY_H) = True Then
                AffText = Not AffText
            End If
            
            
            'if you press on 'PageDown/PageUp' increase/decrease generator power
            '/ Si vous appuyez sur 'PageDown/PageUp' augmente/rduit la puissance du gnrateur
            If .IsKeyPressed(DIK_PGUP) = True Then
                CurrentPower = CurrentPower - (CurrentPower < 5) * TV.TimeElapsed / 100
            End If
            If .IsKeyPressed(DIK_PGDN) = True Then
                CurrentPower = CurrentPower + (CurrentPower > 0) * TV.TimeElapsed / 100
            End If
            
            'change particle size
            If .IsKeyPressed(DIK_Z) = True Then
                Particle.ParticleSize = Particle.ParticleSize - 1
            End If
            If .IsKeyPressed(DIK_X) = True Then
                Particle.ParticleSize = Particle.ParticleSize + 1
            End If
            
            
            'move camera / bouge la camra
            If .IsKeyPressed(TV_KEY_UP) = True Then
                Posx = Posx + TV.TimeElapsed * Cos(ang) * 0.05
                posz = posz + TV.TimeElapsed * Sin(ang) * 0.05
            End If
            If .IsKeyPressed(TV_KEY_DOWN) = True Then
                Posx = Posx - TV.TimeElapsed * Cos(ang) * 0.05
                posz = posz - TV.TimeElapsed * Sin(ang) * 0.05
            End If
            If .IsKeyPressed(TV_KEY_LEFT) = True Then
                ang = ang + TV.TimeElapsed * 0.001
            End If
            If .IsKeyPressed(TV_KEY_RIGHT) = True Then
                ang = ang - TV.TimeElapsed * 0.001
            End If
            
            
            If MoveEmettor = True Then
                a = a + TV.TimeElapsed / 500
                Particle.MoveEmettor Vector(Cos(a) * 50, 50, Sin(a) * 50)
            End If
        End With
    Loop
End With
'Shut down the engine
'/Stoppe le moteur...
Set TV = Nothing
End
End Sub


Private Sub Form_Resize()
TV.ResizeDevice
End Sub


Private Sub Form_Unload(Cancel As Integer)
isRunning = False
End Sub


Private Sub Particle_NewParticle(VelocX As Variant, VelocY As Variant, VelocZ As Variant, ColorR As Variant, ColorG As Variant, ColorB As Variant, ColorA As Variant, LifeTime As Variant, TextureIndex As Variant)
  'Compose the new particle / Compose les valeurs de la nouvelle particule
  LifeTime = CurrentLifeTime
  
  Dim V As D3DVECTOR
  'Change velocity / Change la vlocit
  V = VScale(VNormalize(Vector(Rnd * 2 - 1, Rnd * 4 + 2, Rnd * 2 - 1)), CurrentPower)
  
  VelocX = V.x
  VelocY = V.y
  VelocZ = V.z
  
  'Change Color / Change la couleur
  ColorR = CurrentColor.r
  ColorG = CurrentColor.g
  ColorB = CurrentColor.b
  ColorA = CurrentColor.a
  
End Sub


